npmがわりとゆるふわ過ぎたのでYarnに移行するか検討するためにいろいろやってみた

フロントエンド系技術 フロントエンドエンジニア npm Node.js Yarn

Posted on 2017-02-05


https://yarnpkg.com/

Facebookが作ったというnpmとの互換パッケージマネージャ

Node.js系のパッケージマネージャーといえばnpmです。いろいろありますがかなり便利なのでずっと使ってました。
ただnpmで管理していたパッケージの機能がローカルでは動くけど、どうも本番で動いてないんじゃない?的なことがあって
どうやらそのパッケージのバージョンの違いで動いてない的なことが起こっているんじゃないか疑惑があってnpmってそういえば、
バージョンとかけっこうゆるふわというか多少のバージョンの違いとか気にしなくていいってところがいいんだけど、それって何かあったときにやば過ぎじゃないの?って気になった。
今まで遭遇しなかっただけでバージョンの違いでこんなやらかしがあるのか。。。
じゃあ対策ないの?どうしようかってことでYarnを検討してます。

このYarnですがnpmにはないyarn.lockというファイルが生成されまして、これがまぁRubyのgemなんかだとGemfile.lockというのと同じか似ている感じだと思ってます。
Gemfile.lockは開発環境と運用環境で同じgemをインストールするために使うらしいんですがそれと同じような仕組みになっているという認識。
実際には導入してませんが今のところいい感じで使えてます。npmよりもさくさく動くってところもいい。

Yarnのインストール

インストールはbrewからやるとまあ簡単ですわな。 これはMacの場合ね。ちなみに会社も家のマシンも最近立て続けにmacOS Sierraにしました。

brew update
brew install yarn

念のためにバージョンの確認です。インストールうまくいってたらバージョンでます。 これ書いているときは0.19.1ですね。

yarn --version
0.19.1

Yarnの初期プロジェクト作成的な

で適当にプロジェクトフォルダにうつって

yarn init -y

これでnpmでもお世話になっていたpackage.jsonできます。

ちなみに

npm --version
3.3.12

でnpmでinitしたときにできたpackage.jsonはこれです。

{
  "name": "hoge",
  "version": "1.0.0",
  "description": "",
  "main": "index.js",
  "scripts": {
    "test": "echo \"Error: no test specified\" && exit 1"
  },
  "keywords": [],
  "author": "",
  "license": "ISC"
}

こちらはyarnのinitの場合はこれです。

{
  "name": "01",
  "version": "1.0.0",
  "main": "index.js",
  "repository": {},
  "license": "MIT"
}

ちょっとシンプルになってます。

npmとの違い

npm install jquery --save
yarn add jquery
npm install autoprefixer --save-dev
yarn add autoprefixer --dev

shigeki.takeguchi

渋谷の某ソーシャルゲームの会社でフロントエンドエンジニアとして働いてます。20世紀よりウェブ業界。気づいたらアラフィフ業界人。

By year

  1. 2017 (7)
  2. 2016 (23)
  3. 2015 (13)
  4. 2013 (15)
  5. 2012 (21)
  6. 2011 (34)

© 2012 shigeki.takeguchi